{m25pxx serial eeprom access stuff }
const

ComLength    = 8;
AddLength    = 24;
DataLength   = 8;

{ Instructions }
WriteEnaCom   = $06;
WriteDisCom  = $04;
ReadStatCom  = $05;
WriteStatCom = $01;
ReadCom      = $03;
PageProgCom  = $02;
SectorEraCom = $D8;
BulkEraCom   = $C7;
PowerDown    = $B9;
ReadIDCom    = $AB;

{ status Reg Bits }
WIP = $01;
WEL = $02;
BP0 = $04;
BP1 = $08;
SRWD = $80;

OneMegID = $10;
TwoMegID = $11;
FourMegID = $12;
EightMegID = $13;

type

PageBufferType = array[0..255] of byte;
PageBufferPointer = ^PageBufferType;


{
procedure SetCSHigh;
begin
end;

procedure SetCSLow;
begin
end;



procedure LDisableInterrupts;
begin
  inline($FA);
end;

procedure LEnableInterrupts;
begin
  inline($FB);
end;
}
procedure PutByte(data: byte);
begin
  SendSPIByte(data);
end;

function GetByte : byte;
begin
  Getbyte := RecvSPIByte(0);
end;

procedure PutAddress(add : longint);
begin
  PutByte(WordRec(LongIntRec(add).HighWord).LowByte);
  PutByte(WordRec(LongIntRec(add).LowWord).HighByte);
  PutByte(WordRec(LongIntRec(add).LowWord).LowByte);
end;

procedure Prefix;
begin
  SetCSLow;
end;

procedure Suffix;
begin
  SetCSHigh;
end;

function ReadByte25(add: longint) : byte;
begin
  Prefix;
  PutByte(ReadCom);
  PutAddress(add);
  ReadByte25 := GetByte;
  Suffix;
end;

function ReadStatus25 : byte;
begin
  Prefix;
  PutByte(ReadStatCom);
  ReadStatus25 := GetByte;
  Suffix;
end;

function ReadID25: byte;
begin
  Prefix;
  PutByte(ReadIDCom);
  PutAddress(0); { three dummy bytes}
  ReadID25 := GetByte;
  Suffix;
end;

procedure WriteEnable;
begin
  Prefix;
  PutByte(WriteEnaCom);
  Suffix;
end;

procedure WaitForWrite;
begin
  while (ReadStatus25 and WIP) <> 0 do;
end;

procedure WriteByte(add : longint; data : byte);
begin
  WriteEnable;
  Prefix;
  PutByte(PageProgCom);
  PutAddress(add);
  PutByte(data);
  Suffix;
  WaitForWrite;
end;

procedure WritePage(add : longint; pageBuf : PageBufferPointer);
var
index : word;
begin
  WriteEnable;
  Prefix;
  PutByte(PageProgCom);
  PutAddress(add); { note that add 0..7 should be 0}
  for index := 0 to 255 do
  begin
    PutByte(PageBuf^[index]);
  end;
  Suffix;
  WaitForWrite;
end;

procedure EraseChip;
begin
  WriteEnable;
  Prefix;
  PutByte(BulkEraCom);
  Suffix;
  WaitForWrite;
end;

procedure EraseSector(add: longint);
begin
  WriteEnable;
  Prefix;
  PutByte(SectorEraCom);
  PutAddress(add);
  Suffix;
  WaitForWrite;
end;
