#ifndef __INC_DRVMGR_H
#define __INC_DRVMGR_H

#include "types.h"
#include <winioctl.h>

#define DRIVER_NAME       "mesapci"

#define DRIVER_FUNC_INSTALL     0x01
#define DRIVER_FUNC_REMOVE      0x02

#define	FILE_DEVICE_MESA	0x8000

#define	IOCTL_MESA_DETECT	    \
	CTL_CODE(FILE_DEVICE_MESA, 0x1000, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define	IOCTL_MESA_MAP       	\
	CTL_CODE(FILE_DEVICE_MESA, 0x1001, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define	IOCTL_MESA_UNMAP     	\
	CTL_CODE(FILE_DEVICE_MESA, 0x1002, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define	IOCTL_MESA_GET_MEM	    \
	CTL_CODE(FILE_DEVICE_MESA, 0x1003, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define	IOCTL_MESA_SET_MEM	    \
	CTL_CODE(FILE_DEVICE_MESA, 0x1004, METHOD_BUFFERED, FILE_ANY_ACCESS)

typedef struct _mem_write_msg {
    ULONG addr;
    ULONG data;
} mem_write_msg;

typedef struct _detect_board_msg {
    ULONG vendor;
    ULONG device;
} detect_board_msg;

HANDLE getHandle(void);
int LoadDriver(void);
void UnloadDriver(void);
BOOLEAN InstallDriver(SC_HANDLE SchSCManager, LPCTSTR DriverName, LPCTSTR ServiceExe);
BOOLEAN RemoveDriver(SC_HANDLE SchSCManager, LPCTSTR DriverName);
BOOLEAN StartDriver(SC_HANDLE SchSCManager, LPCTSTR DriverName);
BOOLEAN StopDriver(SC_HANDLE SchSCManager, LPCTSTR DriverName);
BOOLEAN ManageDriver(LPCTSTR DriverName, LPCTSTR ServiceName, USHORT Function);
BOOLEAN SetupDriverName(PUCHAR DriverLocation);

#endif
