
#ifndef __DEVICE_PCI_H
#define __DEVICE_PCI_H

#ifdef __linux__
    #include <pci/pci.h>
#elif _WIN32
    #include "libpci/pci.h"
#endif
#include "eeprom.h"

#define PCI_READ_MEM32(addr) *((u32 *)(mapped_ptr + addr))
#define PCI_WRITE_MEM32(addr, data) do { *((u32 *)(mapped_ptr + addr)) = data; } while (0);

void pci_print_all_info(mesa_board_t *board, int verbose);
int verify_area_pci(char *fname, u32 start_address);
int write_area_pci(mesa_board_t *board, char *fname, u32 start_address);
int open_pci_map(mesa_board_t *board);
int close_pci_map(mesa_board_t *board);

#endif
